Wireshark 2.9.0-477-g68ec514b The Wireshark network protocol analyzer

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Attributes | List of all members
QCPLineEnding Class Reference

Handles the different ending decorations for line-like items. More...

## Public Types
enum | EndingStyle { esNone, esFlatArrow, esSpikeArrow, esLineArrow, esDisc, esSquare, esDiamond, esBar, esHalfBar, esSkewedBar }

## Public Member Functions
| QCPLineEnding ()
| QCPLineEnding (EndingStyle style, double width=8, double length=10, bool inverted=false)
EndingStyle | style () const
double | width () const
double | length () const
bool | inverted () const
void | setStyle (EndingStyle style)
void | setWidth (double width)
void | setLength (double length)
void | setInverted (bool inverted)
double | boundingDistance () const
double | realLength () const
void | draw (QCPPainter *painter, const QVector2D &pos, const QVector2D &dir) const
void | draw (QCPPainter *painter, const QVector2D &pos, double angle) const

## Protected Attributes
EndingStyle | mStyle
double | mWidth
double | mLength
bool | mInverted

## Detailed Description

Handles the different ending decorations for line-like items.

The various ending styles currently supported

For every ending a line-like item has, an instance of this class exists. For example, QCPItemLine has two endings which can be set with QCPItemLine::setHead and QCPItemLine::setTail.

The styles themselves are defined via the enum QCPLineEnding::EndingStyle. Most decorations can be modified regarding width and length, see setWidth and setLength. The direction of the ending decoration (e.g. direction an arrow is pointing) is controlled by the line-like item. For example, when both endings of a QCPItemLine are set to be arrows, they will point to opposite directions, e.g. "outward". This can be changed by setInverted, which would make the respective arrow point inward.

Note that due to the overloaded QCPLineEnding constructor, you may directly specify a QCPLineEnding::EndingStyle where actually a QCPLineEnding is expected, e.g.

myItemLine->setHead(QCPLineEnding::esSpikeArrow)

## Member Enumeration Documentation

enum QCPLineEnding::EndingStyle

Defines the type of ending decoration for line-like items, e.g. an arrow.

The width and length of these decorations can be controlled with the functions setWidth and setLength. Some decorations like esDisc, esSquare, esDiamond and esBar only support a width, the length property is ignored.

See also
  QCPItemLine::setHead, QCPItemLine::setTail, QCPItemCurve::setHead, QCPItemCurve::setTail, QCPAxis::setLowerEnding, QCPAxis::setUpperEnding

Enumerator
esNone | No ending decoration.
esFlatArrow | A filled arrow head with a straight/flat back (a triangle)
esSpikeArrow | A filled arrow head with an indented back.
esLineArrow | A non-filled arrow head with open back.
esDisc | A filled circle.
esSquare | A filled square.
esDiamond | A filled diamond (45 degrees rotated square)
esBar | A bar perpendicular to the line.
esHalfBar | A bar perpendicular to the line, pointing out to only one side (to which side can be changed with setInverted)
esSkewedBar | A bar that is skewed (skew controllable via setLength)

## Constructor & Destructor Documentation

QCPLineEnding::QCPLineEnding | ( |  | ) |

Creates a QCPLineEnding instance with default values (style esNone).

QCPLineEnding::QCPLineEnding | ( | QCPLineEnding::EndingStyle | style,
|  | double | width = `8`,
|  | double | length = `10`,
|  | bool | inverted = `false`
| ) |  |

Creates a QCPLineEnding instance with the specified values.

## Member Function Documentation

double QCPLineEnding::realLength | ( |  | ) | const

Starting from the origin of this line ending (which is style specific), returns the length covered by the line ending symbol, in backward direction.

For example, the esSpikeArrow has a shorter real length than a esFlatArrow, even if both have the same setLength value, because the spike arrow has an inward curved back, which reduces the length along its center axis (the drawing origin for arrows is at the tip).

This function is used for precise, style specific placement of line endings, for example in QCPAxes.

void QCPLineEnding::setInverted | ( | bool | inverted | ) |

Sets whether the ending decoration shall be inverted. For example, an arrow decoration will point inward when inverted is set to true.

Note that also the width direction is inverted. For symmetrical ending styles like arrows or discs, this doesn't make a difference. However, asymmetric styles like esHalfBar are affected by it, which can be used to control to which side the half bar points to.

void QCPLineEnding::setLength | ( | double | length | ) |

Sets the length of the ending decoration, if the style supports it. On arrows, for example, the length defines the size in pointing direction.

See also
  setWidth

void QCPLineEnding::setStyle | ( | QCPLineEnding::EndingStyle | style | ) |

Sets the style of the ending decoration.

void QCPLineEnding::setWidth | ( | double | width | ) |

Sets the width of the ending decoration, if the style supports it. On arrows, for example, the width defines the size perpendicular to the arrow's pointing direction.

See also
  setLength

The documentation for this class was generated from the following files:

- /home/wireshark/builders/wireshark-master/ubuntu-16.04-x64/build/ui/qt/widgets/qcustomplot.h
- /home/wireshark/builders/wireshark-master/ubuntu-16.04-x64/build/ui/qt/widgets/qcustomplot.cpp